Description

mail NK:

es gibt noch ein Desideratum, das wir im Projekt schon identifiziert hatten und das auch Murat schon mal angesprochen hat; weif3
nicht ob schon irgendwo vermerki:

Eine Funktion, mit der eine Matrixzelle manuell als "inapplicable" getaggt werden kann, damit sie von (noch) nicht ausgefillten Zellen
unterschieden werden kann (hilft beim Ausfillen und ist relevant bei weiterer Verwendung der Matrix als e.g. ancestral character
reconstruction zur Unterscheidung von missing characters).

Das impliziert, dass diese Funktion sich tber hinterlegte Statelisten und als numerische State "hinwegsetzen" kann.

mail AM:

ein interessantes Thema. Kannst du das noch ein bisschen weiter ausflihren? Es gibt ja bislang bereits bei den Characters die
Mdglichkeit ,inapplicableif* und ,onlyapplicableif* anzugeben. Das wurde von Xper? abgeschaut und findet bislang bedingt
Anwendung. Vielleicht ist es aber genau das, um was es hier geht. Mein Verstandnis wére, dass man fir jeden Character bzw.
genauer fur jeden Character-Knoten im Character-Baum mit ,inapplicableif‘ angeben kann, welche States Eltern-Characters nicht
annehmen dirfen, damit der Character noch Sinn macht. Wenn ein solcher State doch ausgewahlt wurde, sollte das dazu fuhren,
dass die entsprechende Zelle in der Matrix auf ,inapplicable” bzw. uneditierbar gestellt wird, etc.

Stimmt da mit dem Uberein, was du und Murat brauchen?

Entsprechendes gilt dann nattrlich auch fir onlyapplicableif, nur dass das eine eine Positiv-Liste ist und das andere eine
Negativ-Liste.

mail NK:

ja genau darum geht es, aber diese Optionen bei den Characters wurden ja nicht realisiert (stehen aktuell funktionslos im Character
DetailsView) und irgendwie hatte sich bei mir festgesetzt, dass das zu kompliziert sei, aber das ware natlrlich der elegantere Weg.

mail AM:

Katja, was meinst du, ware das schwierig zu implementieren? Also es geht darum, Felder auszugrauen, ahnlich wie bei den Feldern,
die durch Default Descriptions abgedeckt sind.

Im konkreten Fall miisste geschaut werden, ob der Character-Node des Feldes ein inapplicable-if oder only-applicable-if besitzt.
Wenn ja, mlsste man flr alle Eltern-Character auswerten, welcher Wert/State diesem Character in derselben Description
zugewiesen ist (also in einer der Spalten, die in der Regel weiter links erscheint). Wenn es ein State ist, der in der inapplicable Liste
steht, muss das Feld ausgegraut/nicht editierbar gemacht werden.

Typisches Beispiel: Eine Struktur hat den Character ,present”. Falls hier absent ausgewahlt ist, sollten die Unter-Characters natiirlich
nicht editierbar sein.

Kénntest du daftr ein Ticket anlegen, wenn du denkst, dass das machbar ist?

Natdrlich sollte sich der Zustand on-the-fly &ndern, wenn der State des Eltern-Characters sich andert durchs editieren. Zudem
brauchen wir eine Warnung fiir den Fall, dass Felder inapplicable werden durch eine Anderung in Elternfeldern, wenn aber in den
Kind-Feldern Daten enthalten sind. Die Frage ist auch, ob das Feld dann geldéscht werden soll oder ob es mit einem gut sichtbaren
Hinweis auf fehlerhafte Daten erstmal bestehen bleiben soll. Ich tendiere zu I6schen, aber evil. erst beim Speichern um evtl. ein
Undo méglich zu machen.

Zudem musste man schauen, was ist, wenn der Eltern-Character mehrere Werte hat, also z.B. Blattfarbe rot und griin, und nur rot
als inapplicableif gilt. Ich wiirde sagen, dass dann das inapplicable nicht gilt, bin aber unsicher. Ahnlich bei onlyapplicableif.
Editierbar wenn mind. ein State in only-applicable-if enthalten ist oder wenn alle enthalten sind? Auch hier wirde ich dafur pladieren,
dass mind. ein State ausreicht. Was meinst du, Norbert?

mail NK:

Felder ausgrauen: ja und zugleich mit einem Wert wie "n.a." (= not applicable) fullen, damit bei einem Export diese Felder von
solchen mit fehlenden Daten unterschieden sind.
Multiple states und inapplicable: Ich denke auch, Felder missen editierbar bleiben, solange 1 der multiplen states in
only-applicable-if enthalten ist.

Bei der Auswahl der Bedingungen im only-applicable-if / not applicable if, misste durch + ein Hinzufigen von mehr als einer
Bedingung ermdglicht werden.

Associated revisions

Revision 0da64da4 - 12/01/2021 09:21 AM - Katja Luther

ref #9861: termnode contains featurestate as dto

Revision a55062d3 - 12/01/2021 09:29 AM - Katja Luther

ref #9861: adapt editor to changes in termnodeDto-featurestateDto

Revision dd020291 - 12/01/2021 10:01 AM - Katja Luther

ref #9861: add missing new workbench constant for matrix update

Revision 027a0208 - 12/01/2021 01:44 PM - Katja Luther
ref #9861: check applicability of feature

Revision 5f62bdc2 - 12/01/2021 01:52 PM - Katja Luther

ref #9861: termtree contains map with applicable informations

Revision b7367eb4 - 12/01/2021 02:54 PM - Katja Luther

ref #9861: featurestate save with dto

Revision 33523822 - 12/06/2021 09:06 AM - Katja Luther

ref #9861: smaller changes to fit the logic of inapplicable and only applicable

Revision 8cbae4a4 - 12/06/2021 10:12 AM - Katja Luther
ref #9861: adapt tooltip text

Revision be6d7785 - 12/06/2021 02:39 PM - Katja Luther

ref #9861: do not show values when not applicable

Revision 786a7418 - 12/07/2021 10:22 AM - Katja Luther

ref #9861: do not show values when not applicable - continue

History

#1 - 11/12/2021 01:30 PM - Andreas Miiller

- Tags set to additivity, matrix

#2 - 11/17/2021 05:26 PM - Andreas Miuller

- Target version changed from Unassigned CDM tickets to Release 5.45

This is a feature currently needed for Lactucinae. Therefore we should evaluate if we can implement it soon.

#3 - 12/01/2021 09:20 AM - Katja Luther

- Subject changed from [CharacterMatrix] Provide possibility to set a field as inapplicable to Provide possibility to set a field as inapplicable

#4 - 12/01/2021 09:20 AM - Katja Luther

- Status changed from New to In Progress

#5 - 12/01/2021 01:49 PM - Katja Luther
- % Done changed from 0 to 40

The termTreeDto contains maps, holding the information about which features relates on the presence or absence of a state of a parent feature.
These maps are used to calculate the enable/disable status of a field in character matrix.
#6 - 12/06/2021 12:56 PM - Katja Luther

Norbert Kilian wrote
Felder ausgrauen: ja und zugleich mit einem Wert wie "n.a." (= not applicable) fullen, damit bei einem Export diese Felder von solchen mit
fehlenden Daten unterschieden sind.

Actually the implementation works only for the character matrix. If the character is not appicable the field can not be edited and a tooltip explains why.

Maybe we should discuss whether we want to add a value "n. a." in database or if it is also possible to handle this in exports. We also should think
about how we handle values already added.

If we want to add a specific value "n. a." this should be handled while saving.
